
> module Main where

> import Monad
> import Args
> import Positionise
> import Lex
> import Parse
> import Output_code
> import Output_diag
> import System
> import Tree

> main :: IO ()
> main = do c <- getContents
>           args <- getArgs
>           let config = parse_args args
>               output = case config of
>                            Code _ _ -> output_code
>                            Diags _ _ -> output_diag
>           (output config . interesting_defs . parse . scan . positionise) c

> interesting_defs :: Tree -> Tree
> interesting_defs (Tree t ds) = Tree t (filter interesting_def ds)

> interesting_def :: Def -> Bool
> interesting_def (Def b _ _) = b

