
> module Opt (opt) where

> import Tree
> import List
> import Char

data Tree = Tree [Either Line Def]
data Line = Line String
data Def = Def Bool Name String
type Name = String

> opt :: Tree -> Tree
> opt (Tree t) = Tree (ox (get_words $ get_lines t) t)

> get_words :: [String] -> [String]
> get_words = map rem_slash . get_words' . concat . intersperse " " . map (takeWhile ('%' /=))

> is_name_char :: Char -> Bool
> is_name_char c = isAlphaNum c || c == '_' || c == '.'

> get_words' :: String -> [String]
> get_words' "" = []
> get_words' cs@(c:_)
>   | is_name_char c = takeWhile is_name_char cs:get_words' (dropWhile is_name_char cs)
>   | otherwise      = get_words' (dropWhile (not . is_name_char) cs)

> rem_slash :: String -> String
> rem_slash ('/':s) = s
> rem_slash s = s

> get_lines :: [Either Line Def] -> [String]
> get_lines [] = []
> get_lines (Left (Line s):xs) = s:get_lines xs
> get_lines (_:xs) = get_lines xs

> ox :: [String] -> [Either Line Def] -> [Either Line Def]
> ox ss xs = case o ss xs of
>                ([], xs') -> xs'
>                (ss', xs') -> ox ss' xs'

> o :: [String] -> [Either Line Def] -> ([String], [Either Line Def])
> o _ [] = ([], [])
> o ss (Right d@(Def False n s):xs) = (these ++ ss', Right this:xs')
>  where (this, these) = if n `elem` ss then (Def True n s, get_words (lines s))
>                                       else (d, [])
>        (ss', xs') = o ss xs
> o ss (x:xs) = (ss', x:xs')
>  where (ss', xs') = o ss xs

